"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var utils_1 = require("../utils/utils");
var parse_1 = require("../utils/parse");
var FilterByPipe = (function () {
    function FilterByPipe() {
        this.$parse = parse_1.Parse();
    }
    FilterByPipe.prototype.transform = function (collection, properties, search, strict) {
        var _this = this;
        if (strict === void 0) { strict = false; }
        if (!utils_1.isArray(collection)) {
            collection = utils_1.toArray(collection);
        }
        search = utils_1.isString(search) || utils_1.isNumber(search)
            ? String(search).toLowerCase()
            : undefined;
        if (!utils_1.isArray(collection) || utils_1.isUndefined(search)) {
            return collection;
        }
        if (utils_1.isString(search) || utils_1.isNumber(search)) {
            search = String(search).toLowerCase();
        }
        return collection.filter(function (elm) {
            return properties.some(function (prop) {
                /**
                * check if there are concatenate properties
                * example:
                * object: { first: 'foo', last:'bar' }
               * filterBy: ['first + last'] => search by full name(i.e 'foo bar')
               */
                var comparator;
                if (!~prop.indexOf('+')) {
                    comparator = _this.$parse(prop)(elm);
                }
                else {
                    var propList = prop.replace(/\s+/g, '').split('+');
                    comparator = propList
                        .map(function (p) { return _this.$parse(p)(elm); })
                        .join(' ');
                }
                // TODO: boolean?
                if (!utils_1.isString(comparator) && !utils_1.isNumber(comparator)) {
                    return false;
                }
                comparator = String(comparator).toLowerCase();
                // indentical or contains
                return strict
                    ? comparator === search
                    : comparator.indexOf(search) != -1;
            });
        });
    };
    return FilterByPipe;
}());
FilterByPipe = __decorate([
    core_1.Pipe({
        name: 'filterBy'
    }),
    __metadata("design:paramtypes", [])
], FilterByPipe);
exports.FilterByPipe = FilterByPipe;
//# sourceMappingURL=filter-by.pipe.js.map